/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * $Id: conf.h,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#ifndef __CONFIG_H__
#define __CONFIG_H__

/*
* Library onto a readable, ascii data-tree format.

server="192.168.1.202" {
  port=9032
  disallow {
    address="192.168.1.19"
    address="192.168.1.250"
  }
}

*/

typedef struct {
  int           parentindex;
  char*         name;
  char*         value;
} conf_node_t;

typedef struct {
  conf_node_t* list;
  int          count;
  int          fd;
} conf_t;

conf_t* c_swallow(char* path);
conf_t* c_open(char* path);
conf_t* c_create();
conf_t* c_parse(char* string);
conf_t* c_copy(conf_t* original, int node);
int     c_save(conf_t* c);
void    c_close(conf_t* c);
void    c_closefd(conf_t* c);

int c_first_child(conf_t* conf, int node);
int c_next_brother(conf_t* conf, int node);

int c_first_child_named(conf_t* conf, int node, char* name);
int c_next_brother_named(conf_t* conf, int node, char* name);

int c_first_child_casenamed(conf_t* conf, int node, char* name);
int c_next_brother_casenamed(conf_t* conf, int node, char* name);

char* c_first_child_value_named(conf_t* conf, int node, char* name);
char* c_next_brother_value_named(conf_t* conf, int node, char* name);

int c_get_index(conf_t* conf, int node);

int c_add_child(conf_t* conf, int node, char* name, char* value);
int c_add_brother(conf_t* conf, int node, char* name, char* value);

int c_add_child_int(conf_t* conf, int node, char* name, int value);
int c_add_brother_int(conf_t* conf, int node, char* name, int value);
int c_set(conf_t* conf, int node, char* value);

char* c_name(conf_t* conf, int node);
char* c_value(conf_t* conf, int node);


int c_value_int(conf_t* conf, int node);

char* c_name_strncpy(conf_t* conf, int node, char* buffer, int size);
char* c_value_strncpy(conf_t* conf, int node, char* buffer, int size);

char* c_strdup(conf_t* conf, int tight);

char* c_query(conf_t* conf, char* query);
char* c_qsprintf(conf_t* conf, char* queryformat, ...);

#endif
