#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

int socketfd(char* path) {
  struct sockaddr_un s_un;
  int s = socket(AF_UNIX, SOCK_STREAM, 0);
  memset(&s_un, 0, sizeof(s_un));
  s_un.sun_family = AF_UNIX;
  strcpy(s_un.sun_path, path);
  if (connect(s, (struct sockaddr *)&s_un, SUN_LEN(&s_un)) < 0) {
perror("connect:");
    close(s);
    s = -1;
  }
  return s;
}

#include <netdb.h>

int main(int argc, char** args) {
  FILE* in = stdin;
  FILE* out = stdout;
  int sfd;
  int n, bufsiz = 8 * 1024;
  char buffer[bufsiz];
  if (argc == 4) {
    if (strcmp(args[2], "stdin")) in = fopen(args[2], "r");
    if (strcmp(args[3], "stdout")) out = fopen(args[3], "w");
    if (!in) {
      fprintf(stderr, "Could not open %s for reading.\n", args[2]);
    }
    if (!out) {
      fprintf(stderr, "Could not open %s for writing.\n", args[3]);
    }
    if (!in || !out) exit(-1);
  } else {
    printf("usage: %s path (filename|'stdin') "
           "(filename|'stdout')\n", args[0]);
    return -1;
  }
  if ((sfd = socketfd(args[1])) != -1) {
    while ((n = fread(buffer, 1, bufsiz, in))) {
      write(sfd, buffer, n);
    }
    while ((n = read(sfd, buffer, bufsiz))) {
      fwrite(buffer, 1, n, out);
    }
    close(sfd);
  } else {
    fprintf(stderr, "could not connect.\n");
    return -1;
  }
  return 0;
}
