/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * $Id: httpc_format.h,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#ifndef _HTTPC_DB_H_
#define _HTTPC_DB_H_

#include "httpc.h"

/*
* In general:
* This code maintains all of one server's chatboxes in a btree in memory
* and (maybe) on disk (if PATH is given).  Keys have always the same size:
* BOXNAMESIZE + sizeof(time_t).  Values are a stringified hash that always
* contain a value for 'line'.
* Furthermore, these functions contain code for synchronized access to the db,
* since they will probably be called by a variety of threads all at once.
*/

  /*
  * Inits a db and a mutex, returns zero on success.
  */

int httpc_db_init(httpc_server_t* server, char* path);

  /*
  * closes the db and the mutex.
  */

void httpc_db_free(httpc_server_t* server);

  /*
  * Inserts the line into the db, returns zero on success.
  */

int httpc_db_insert(client_t* client, char* line);

  /*
  * Retrieves up to SIZE lines from the db from this box and strdups the
  * data into ARRAY.  Returns the amount of ARRAY filled.
  */

int httpc_db_dup_lines(client_t* client, char** array, int size);

#endif
