/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * credits to "Kees Jan Hermans" <kees@orgnet.nl>
 * many new bugs added by "Niels Poppe" <niels@netbox.org>
 * $Id: httpc_format.c,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#include "httpc_format.h"
#include "httpc_util.h"

char* httpcP_resolve_var(char* s, int l, conf_t* c1, conf_t* c2, conf_t* c3) {
  int n;
  char swap = s[l];
  s[l] = 0;
  if (c1 && (n = c_first_child_named(c1, -1, s)) != -1) {
    s[l] = swap;
    return c_value(c1, n);
  }
  if (c2 && (n = c_first_child_named(c2, -1, s)) != -1) {
    s[l] = swap;
    return c_value(c2, n);
  }
  if (c3 && (n = c_first_child_named(c3, -1, s)) != -1) {
    s[l] = swap;
    return c_value(c3, n);
  }
  s[l] = swap;
  return NULL;
}

char* httpc_format_dup(client_t* c, char* template,
                       conf_t* c1, conf_t* c2, conf_t* c3) {
  char* s, * result = strdup(template);
  while (result && (s = strchr(result, '$')) && *(s+1) == '{') {
    char* end = strchr(s+2, '}');
    if (end) {
      int offset, oldlen, newlen, leftlen;
      char* value = httpcP_resolve_var(s+2, end-(s+2), c1, c2, c3);
      char emptystring[] = "";
      if (!value) {
        value = emptystring;
      }
      offset  = (s-result);
      oldlen  = (end-s) + 1;
      newlen  = strlen(value);
      leftlen = strlen(end+1)+1;
      if (newlen-oldlen > 0) {
        result = (char*)realloc(result, strlen(result)+1 + (newlen-oldlen));
      }
      if (result) {
        memmove(result + offset + newlen,
                result + offset + oldlen,
                leftlen);
        if (newlen) {
          memcpy(result + offset, value, newlen);
        }
      }
    }
  }
  return result;
}

int httpc_format_stream(client_t* c, char* template,
                        conf_t* c1, conf_t* c2, conf_t* c3) {
  char* s = template;
  while (*s) {
    if (*s == '$') {
      if (*(s+1) == '$') {
        if (write(c->fd, s++, 1) < 0) return -1;
      } else if (*(s+1) == '{') {
        char* end = strchr(s+2, '}');
        if (end) {
          char* value = httpcP_resolve_var(s+2, end-(s+2), c1, c2, c3);
          if (value) {
            if (fdwrite(c->fd, value)) return -1;
          }
          s = end;
        }
      } else {
        if (write(c->fd, s, 1) < 0) return -1;
      }
    } else {
      if (write(c->fd, s, 1) < 0) return -1;
    }
    ++s;
  }
  return 0;
}
