/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * credits to "Kees Jan Hermans" <kees@orgnet.nl>
 * many new bugs added by "Niels Poppe" <niels@netbox.org>
 * $Id: httpc_inet.c,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#include "httpc_inet.h"

#ifdef WIN32
#define snprintf _snprintf
#else
#define closesocket close
#endif

int clientsocketfd(struct in_addr address, short int port) {
  int s;
  struct sockaddr_in s_in;
  memset(&s_in, 0, sizeof(s_in));
  s_in.sin_family = AF_INET;
  s_in.sin_port = htons(port);
  s_in.sin_addr = address;

#ifdef WIN32
  WORD wVersion = MAKEWORD(2,0);
  WSADATA wsaData;
  WSAStartup(wVersion, &wsaData);
#endif

  s = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (s < 0) {
    return -1;
  }
  if (connect(s, (struct sockaddr *)&s_in, sizeof(s_in)) != 0) {
    closesocket(s);

#ifdef WIN32
    WSACleanup();
#endif

    s = -1;
  }
  return s;
}

int resolve(char* host, struct in_addr* out) {
  unsigned long int address;
  if ((address = inet_addr(host)) == INADDR_NONE) {
    struct hostent* hostent = gethostbyname(host);
    if (hostent) {
      char** alist = hostent->h_addr_list;
      memcpy(out, *alist, hostent->h_length);
      return 0;
    }
  } else {
    memcpy(out, &address, sizeof(*out));
    return 0;
  }
  return -1;
}
