/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * $Id: httpc_parse.h,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#ifndef _HTTPC_PARSE_H_
#define _HTTPC_PARSE_H_

#include "conf.h"

#define HTTPC_MAXPATH 512
#define MAXPOSTSIZE (64*1024)

#define HTTP_METHOD_GET  1
#define HTTP_METHOD_POST 2

struct httprequest {
  short          method;
  unsigned short proto_major;
  unsigned short proto_minor;
  conf_t*        headers;
  conf_t*        query;
  char           path[HTTPC_MAXPATH];
};

/*
* The headers are all MIME-headers of the http request, including the
* first line, including the double \r\n at the end, but the fd of
* the http connection must be given in order to appropriately handle
* POSTs.
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#ifdef _DEBUG
int httpc_parse_request(struct in_addr ina, short port,
                        struct httprequest* req, char* headers, int fd);
#else
int httpc_parse_request(struct in_addr ina,
                        struct httprequest* req, char* headers, int fd);
#endif

void httpc_free_request(struct httprequest* req);

#endif
