/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * credits to "Kees Jan Hermans" <kees@orgnet.nl>
 * many new bugs added by "Niels Poppe" <niels@netbox.org>
 * $Id: httpc_test.c,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#include "httpc_inet.h"

int dontstop = 0;

int playhttpclient(struct in_addr ina, int port, int index) {
  int csfd = clientsocketfd(ina, port);
  if (csfd >= 0) {
    char buffer[128];
//    snprintf(buffer, 128, "GET /?this+is+a+test+%d HTTP/1.0\r\n\r\n", index);
    snprintf(buffer, 128, "GET /hello?%d HTTP/1.0\r\n\r\n", index);
    if (write(csfd, buffer, strlen(buffer)) < 0) {
      perror("write");
      close(csfd);
      return -1;
    }
    close(csfd);
    return 0;
  }
  perror("connect");
  return -1;
}

int doitdoit(struct in_addr ina, int port, int strobe, int dolong) {
  int stopat = time(NULL) + ((dolong) ? 3600 : 0);
  int index = 0;
  do {
    int amount = 1+(int) (20.0*rand()/(RAND_MAX+1.0));
    int usleeptime = 100+(int) (500.0*rand()/(RAND_MAX+1.0));
    int errors = 0, i;
    fprintf(stderr, "Shooting %d; sleeping %d ", amount, usleeptime);
    for (i=0; i<amount; i++) {
      if (playhttpclient(ina, port, index++)) {
        errors++;
        fprintf(stderr, "!");
      } else {
        fprintf(stderr, ".");
      }
      fflush(stderr);
    }
    fprintf(stderr, " %d errors.\n", errors);
    if (errors == amount && !dontstop) {
      fprintf(stderr, "All errors; quit.\n");
      return -1;
    }
    usleep(usleeptime*1000);
  } while (time(NULL) < stopat);
  return 0;
}

int doit(char* host, int port, char* mode) {
  struct in_addr ina;
  int strobe = 0, dolong = 0;
  if (resolve(host, &ina) == 0) {
    if (strchr(mode, 's')) {
      strobe = 1;
    }
    if (strchr(mode, 'l')) {
      dolong = 1;
    }
    if (strchr(mode, 'd')) {
      dontstop = 1;
    }
    return doitdoit(ina, port, strobe, dolong);
  }
  return -1;
}

/*
* Called with $0 host port mode
*/

int main(int argc, char* argv[]) {
  if (argc == 4) {
    char* host = argv[1];
    char* port = argv[2];
    char* mode = argv[3];
    srand(time(NULL));
    return doit(host, atoi(port), mode);
  }
  printf("Usage %s host port mode('s'=strobe,'l'=long)\n", argv[0]);
  return -1;
}
