/*
 * (C) 2000 ORG.NET bv, The Hague, Netherlands.
 * credits to "Kees Jan Hermans" <kees@orgnet.nl>
 * many new bugs added by "Niels Poppe" <niels@netbox.org>
 * $Id: main.c,v 1.2 2000/11/06 11:06:59 niels Exp $
*/
#include <signal.h>

#include "httpc.h"

httpc_t* httpc = NULL;

void sigHandler(int signal) {
  if (signal == SIGHUP) {
    //.. restart
  } else if (httpc) {
    httpc_t* pointercopy = httpc;
    httpc = NULL;
    fprintf(stderr, "Signal caught.\n");
    httpc_stop(pointercopy);
  }
}

#ifdef _INJECTDATE
#include "builddate.h"
#endif

int main(int argc, char* argv[]) {
  signal(SIGTERM, sigHandler);
  signal(SIGINT, sigHandler);
  signal(SIGHUP, sigHandler);
  httpc = httpc_init(NULL);
#ifdef _INJECTDATE
  fprintf(stderr, "---- Build date %s version %d.%d.\n"
                  , builddate
                  , VERSION_MAJOR
                  , VERSION_MINOR
         );
#endif
  if (httpc) {
    return httpc_start(httpc);
  }
  return -1;
}
